﻿using Microsoft.AspNetCore.Mvc;
using Syncfusion.EJ2.Base;
using Syncfusion.EJ2.Linq;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using SUCOCoreControl.Models;
using SUCOCoreControl.Models.RazorBudget;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace SUCOCoreControl.Controllers
{
    public class HeadersController : Controller
    {
        public static List<Header> hdrdata = new List<Header>();
        public ActionResult Index()
        {
            return View();
        }

        public class ExtendedDataManager : DataManagerRequest
        {
            // public IDictionary<string, string> @params;
        }
        public ActionResult UrlDatasource([FromBody]ExtendedDataManager dm)
        {
            IEnumerable DataSource = hdrdata.ToList();
            DataOperations operation = new DataOperations();
            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = operation.PerformSearching(DataSource, dm.Search);  //Search
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = operation.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {

                DataSource = operation.PerformFiltering(DataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = DataSource.Cast<Header>().Count();
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);   //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            return Json(new { result = DataSource, count = count });
        }

        public ActionResult Update([FromBody] CRUDModel myObject)
        {
            var hdr = myObject.Value;
            Header val = hdrdata.Where(or => or.HeaderID == hdr.HeaderID).FirstOrDefault();
            val.HeaderID = hdr.HeaderID;
            val.ProjectID = hdr.ProjectID;
            val.HeaderENG = hdr.HeaderENG;
            val.HeaderARB = hdr.HeaderARB;

            return Json(myObject.Value);

        }
        public ActionResult Insert([FromBody] CRUDModel myObject)
        {
            var hdr = myObject.Value;
            hdrdata.Insert(0, hdr);
            return Json(myObject.Value);
        }

        public ActionResult Remove([FromBody] CRUDModel value)
        {
            hdrdata.Remove(hdrdata.Where(or => or.HeaderID == value.key).FirstOrDefault());
            return Json(new { result = hdrdata, count = hdrdata.Count });
        }

        public class CRUDModel
        {
            public List<Header> Added { get; set; }
            public List<Header> Changed { get; set; }
            public List<Header> Deleted { get; set; }
            public Header Value { get; set; }

            public string ej2grid { get; set; }
            public string key { get; set; }
            public string type { get; set; }
            public string optr { get; set; }
            public string action { get; set; }
        }

        //public class param
        //{
        //    public string type { get; set; }
        //    public string optr { get; set; }
        //}

        public class Header
        {
            public Header()
            {
                SubHeader = new HashSet<SubHeader>();
            }

            [StringLength(6)]
            public string ProjectID { get; set; }
            [StringLength(30)]
            public string HeaderID { get; set; }
            [StringLength(60)]
            public string HeaderENG { get; set; }
            [StringLength(60)]
            public string HeaderARB { get; set; }

            [ForeignKey("ProjectID")]
            [InverseProperty("Header")]
            public virtual Project Project { get; set; }
            [InverseProperty("Header")]
            public virtual ICollection<SubHeader> SubHeader { get; set; }
        }
        //public class Employee1Details
        //{
        //    public static List<Employee1Details> order = new List<Employee1Details>();
        //    public Employee1Details()
        //    {

        //    }
        //    public Employee1Details(int EmployeeId, string FirstName, string LastName, int ReportsTO)
        //    {
        //        this.EmployeeID = EmployeeId;
        //        this.FirstName = FirstName;
        //        this.LastName = LastName;
        //        this.ReportsTo = ReportsTo;
        //    }
        //    public static List<Employee1Details> GetAllRecords()
        //    {
        //        if (order.Count() == 0)
        //        {
        //            for (int i = 1; i < 2; i++)
        //            {
        //                order.Add(new Employee1Details(i + 0, "Nancy", "Davolio", i + 0));
        //                order.Add(new Employee1Details(i + 1, "Andrew", "Fuller", i + 3));
        //                order.Add(new Employee1Details(i + 2, "Janet", "Leverling", i + 2));
        //                order.Add(new Employee1Details(i + 3, "Margaret", "Peacock", i + 1));

        //            }
        //        }
        //        return order;
        //    }


        //    public int? EmployeeID { get; set; }
        //    public string FirstName { get; set; }
        //    public string LastName { get; set; }
        //    public int? ReportsTo { get; set; }
        //}
    }
}

